summaryrefslogtreecommitdiff
path: root/meta-google
diff options
context:
space:
mode:
authorWilliam A. Kennington III <wak@google.com>2021-11-05 14:15:36 +0300
committerWilliam A. Kennington III <wak@google.com>2021-11-06 02:40:43 +0300
commit58ac4343a47e69e6c23f7f3128b6da1b9d922a91 (patch)
tree0bae6d81e7c88eee8217d04b44dece8827811a8c /meta-google
parentcefbd1cf61ec037f62b7f5cfe93c727ed234226a (diff)
downloadopenbmc-58ac4343a47e69e6c23f7f3128b6da1b9d922a91.tar.xz
meta-google: gbmc-bridge: Defer address reconfiguration
Reconfiguring network interfaces immediately after detecting changes may not allow them enough time to settle. Without waiting, we might pre-emptively assume the configuration is changing even though networkd is just flushing and resetting the interface with the same config. Change-Id: I6a6858578d0499305fe2a3d3592dc73533bb02f1 Signed-off-by: William A. Kennington III <wak@google.com>
Diffstat (limited to 'meta-google')
-rw-r--r--meta-google/recipes-google/ncsi/files/gbmc-ncsi-br-pub-addr.sh.in9
-rw-r--r--meta-google/recipes-google/networking/gbmc-bridge/gbmc-br-from-ra.sh10
2 files changed, 13 insertions, 6 deletions
diff --git a/meta-google/recipes-google/ncsi/files/gbmc-ncsi-br-pub-addr.sh.in b/meta-google/recipes-google/ncsi/files/gbmc-ncsi-br-pub-addr.sh.in
index ce53b8efb..5adc41328 100644
--- a/meta-google/recipes-google/ncsi/files/gbmc-ncsi-br-pub-addr.sh.in
+++ b/meta-google/recipes-google/ncsi/files/gbmc-ncsi-br-pub-addr.sh.in
@@ -16,9 +16,12 @@
gbmc_ncsi_br_pub_addr_init=
gbmc_ncsi_br_pub_addr_lastip=
+gbmc_ncsi_br_pub_addr_confip=
gbmc_ncsi_br_pub_addr_update() {
[ -n "$gbmc_ncsi_br_pub_addr_init" ] || return
+ [ "$gbmc_ncsi_br_pub_addr_confip" != "$gbmc_ncsi_br_pub_addr_lastip" ] || return
+ gbmc_ncsi_br_pub_addr_confip="$gbmc_ncsi_br_pub_addr_lastip"
printf 'gBMC Bridge Pub Addr from NCSI: %s\n' \
"${gbmc_ncsi_br_pub_addr_lastip:-(deleted)}" >&2
@@ -85,17 +88,19 @@ EOF
gbmc_ncsi_br_pub_addr_hook() {
if [ "$change" = 'init' ]; then
gbmc_ncsi_br_pub_addr_init=1
+ gbmc_ip_monitor_defer
+ elif [ "$change" = 'defer' ]; then
gbmc_ncsi_br_pub_addr_update
elif [ "$change" = 'addr' -a "$intf" = '@NCSI_IF@' ] &&
[ "$scope" = 'global' -a "$fam" = 'inet6' ] &&
[[ "$flags" != *deprecated* ]]; then
if [ "$action" = 'add' -a "$ip" != "$gbmc_ncsi_br_pub_addr_lastip" ]; then
gbmc_ncsi_br_pub_addr_lastip="$ip"
- gbmc_ncsi_br_pub_addr_update
+ gbmc_ip_monitor_defer
fi
if [ "$action" = 'del' -a "$ip" = "$gbmc_ncsi_br_pub_addr_lastip" ]; then
gbmc_ncsi_br_pub_addr_lastip=
- gbmc_ncsi_br_pub_addr_update
+ gbmc_ip_monitor_defer
fi
fi
}
diff --git a/meta-google/recipes-google/networking/gbmc-bridge/gbmc-br-from-ra.sh b/meta-google/recipes-google/networking/gbmc-bridge/gbmc-br-from-ra.sh
index 18341fefb..a9bfd74af 100644
--- a/meta-google/recipes-google/networking/gbmc-bridge/gbmc-br-from-ra.sh
+++ b/meta-google/recipes-google/networking/gbmc-bridge/gbmc-br-from-ra.sh
@@ -67,26 +67,28 @@ gbmc_br_from_ra_update() {
gbmc_br_from_ra_hook() {
if [ "$change" = 'init' ]; then
gbmc_br_from_ra_init=1
+ gbmc_ip_monitor_defer
+ elif [ "$change" = 'defer' ]; then
gbmc_br_from_ra_update
elif [[ "$change" == 'route' && "$route" != *' via '* ]] &&
[[ "$route" =~ ^(.* dev gbmcbr proto ra .*)( +expires +([^ ]+)sec).*$ ]]; then
pfx="${route%% *}"
if [ "$action" = 'add' ]; then
gbmc_br_from_ra_pfxs["$pfx"]="${BASH_REMATCH[3]}"
- gbmc_br_from_ra_update
+ gbmc_ip_monitor_defer
elif [ "$action" = 'del' ]; then
gbmc_br_from_ra_pfxs["$pfx"]=0
- gbmc_br_from_ra_update
+ gbmc_ip_monitor_defer
fi
elif [ "$change" = 'link' -a "$intf" = 'gbmcbr' ]; then
rdisc6 -m gbmcbr -r 1 -w 100 >/dev/null 2>&1
if [ "$action" = 'add' -a "$mac" != "$gbmc_br_from_ra_mac" ]; then
gbmc_br_from_ra_mac="$mac"
- gbmc_br_from_ra_update
+ gbmc_ip_monitor_defer
fi
if [ "$action" = 'del' -a "$mac" = "$gbmc_br_from_ra_mac" ]; then
gbmc_br_from_ra_mac=
- gbmc_br_from_ra_update
+ gbmc_ip_monitor_defer
fi
fi
}